package fr.plil.sio.persistence.api;

import javax.persistence.*;
import java.util.HashSet;
import java.util.Set;

@Entity
@Table(name = "RIGHT_T")
public class Right {

    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    @Column(name = "RIGHT_ID")
    private Long id;

    @Column(name = "NAME_C")
    private String name;

    /// the parent right
    @ManyToOne
    @JoinColumn(name = "PARENT_C")
    private Right parent;

    /// the sibling right(s), eventually empty
    @OneToMany(mappedBy = "parent")
    private Set<Right> siblings = new HashSet<>();

    public Set<Right> getSiblings() {
        return siblings;
    }

    public void setSiblings(Set<Right> siblings) {
        this.siblings = siblings;
    }

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public Right getParent() {
        return parent;
    }

    public void setParent(Right parent) {
        this.parent = parent;
    }
}
